unit tel64_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, Menus;

type
  S08_ = string

    [8];

const
  Version_ = ' Tél64 - v1.5.1 by Didier GERARD';

  JourSemaine_: array[1..7] of S08_ =
    ('Dimanche', 'Lundi', 'Mardi', 'Mecredi', 'Jeudi', 'Vendredi', 'Samedi');
  //Couleurs
  ColFond1_ = $00FFA74F;//Panel1
  ColFond2_ = $00B0A786;//panel2
  ColRouge_ = $008484FF;
  ColAff_ = $00DDD9CC;
  //Couleurs Champs Recherche
  ColF00_ = $009B9BFF;
  //Couleurs Champs Fiche
  ColF10_ = $00C0FF82;
  ColF11_ = $00E0FFC1;
  ColF20_ = clLime;
  ColF21_ = $00B3FFB3;
  ColF30_ = clYellow;
  ColF31_ = $00B7FFFF;
  ColF40_ = $00D6BBA3;
  ColF41_ = $00E4D2C2;
  ColF50_ = $0051A8FF;
  ColF51_ = $00AAD5FF;

  L020_ = 20;
  L030_ = 30;
  L050_ = 50;
  //Data
  DataNom_ = 'Tel64.dat';
  DataNomCSV_ = 'Tel64.csv';
  DataFichesMax_ = 999;
  DataChampsMax_ = 13;

type
  //Data
  Fiche_ = record
    Design: string[L050_];
    Com: string[L050_];
    Categ: string[L030_];

    Nom: string[L030_];
    Prenom: string[L030_];

    Rue: string[L050_];
    Ville: string[L050_];

    Tel1: string[L020_];
    Tel2: string[L020_];
    Tel3: string[L020_];
    Tel4: string[L020_];

    Mail1: string[L030_];
    Mail2: string[L030_];
  end;
  Data_ = array[1..DataFichesMax_] of Fiche_;

  { TWdMain }

  TWdMain = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox4: TCheckBox;
    Ed01: TEdit;
    Ed10: TEdit;
    Ed11: TEdit;
    Ed12: TEdit;
    Ed02: TEdit;
    Ed03: TEdit;
    Ed04: TEdit;
    Ed05: TEdit;
    Ed06: TEdit;
    Ed07: TEdit;
    Ed08: TEdit;
    Ed09: TEdit;
    Ed13: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    EdRech: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Pn08: TPanel;
    Pn09: TPanel;
    Pn11: TPanel;
    Pn12: TPanel;
    Panel2: TPanel;
    Pn01: TPanel;
    Pn02: TPanel;
    Pn03: TPanel;
    Pn04: TPanel;
    Pn05: TPanel;
    Pn06: TPanel;
    Pn07: TPanel;
    Pn10: TPanel;
    Pn13: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox4Change(Sender: TObject);
    procedure Ed01Change(Sender: TObject);
    procedure Ed02Change(Sender: TObject);
    procedure Ed03Change(Sender: TObject);
    procedure Ed04Change(Sender: TObject);
    procedure Ed05Change(Sender: TObject);
    procedure Ed06Change(Sender: TObject);
    procedure Ed07Change(Sender: TObject);
    procedure Ed08Change(Sender: TObject);
    procedure Ed09Change(Sender: TObject);
    procedure Ed10Change(Sender: TObject);
    procedure Ed11Change(Sender: TObject);
    procedure Ed12Change(Sender: TObject);
    procedure Ed13Change(Sender: TObject);
    procedure EdRechChange(Sender: TObject);
    procedure EdRechKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;

  DirExe: string;
  MemDate: TDate;

  Modif: boolean = False;
  //Data
  Data: Data_;
  DataNom: string;
  //Copier/Coller
  FicheMem1: Fiche_;
  FicheMem2: Fiche_;
  //Recherche : Mem. champs
  RechChamps: integer;


implementation

{$R *.lfm}

{ TWdMain }

function Jour_Date: string;
var
  s: string;
begin
  s := JourSemaine_[DayOfWeek(Now)];
  s := s + '  ' + DateToStr(Now);
  Result := s;
end;

function If_Data_Fiche_Vide(Nb: integer): boolean;
var
  Ok: boolean;
begin
  Ok := True;
  with Data[Nb] do
  begin
    if Design <> '' then
      Ok := False;
    if Com <> '' then
      Ok := False;
    if Categ <> '' then
      Ok := False;
    if Nom <> '' then
      Ok := False;
    if Prenom <> '' then
      Ok := False;
    if Rue <> '' then
      Ok := False;
    if Ville <> '' then
      Ok := False;
    if Tel1 <> '' then
      Ok := False;
    if Tel2 <> '' then
      Ok := False;
    if Tel3 <> '' then
      Ok := False;
    if Tel4 <> '' then
      Ok := False;
    if Mail1 <> '' then
      Ok := False;
    if Mail2 <> '' then
      Ok := False;
  end;
  Result := Ok;
end;

procedure Data_Nb_Fiches;
var
  n, Oc, Lb: integer;
begin
  Oc := 0;
  Lb := 0;
  with WdMain do
  begin
    for n := 1 to DataFichesMax_ do
    begin
      if If_Data_Fiche_Vide(n) then
        Inc(Lb)
      else
        Inc(Oc);
    end;
    Edit2.Text := IntToStr(Oc);
    Edit3.Text := IntToStr(Lb);
    if Lb = 0 then
      Edit3.Color := ColRouge_
    else
      Edit3.Color := ColAff_;
  end;
end;

procedure Edit_vers_Data(DataEnCours, Select: integer);
begin
  with WdMain do
  begin
    if (DataEnCours > 0) and (DataEnCours <= DataFichesMax_) then
    begin
      case select of
        1: Data[DataEnCours].Design := Ed01.Text;
        2: Data[DataEnCours].Com := Ed02.Text;
        3: Data[DataEnCours].Categ := Ed03.Text;
        4: Data[DataEnCours].Nom := Ed04.Text;
        5: Data[DataEnCours].Prenom := Ed05.Text;
        6: Data[DataEnCours].Rue := Ed06.Text;
        7: Data[DataEnCours].Ville := Ed07.Text;
        8: Data[DataEnCours].Tel1 := Ed08.Text;
        9: Data[DataEnCours].Tel2 := Ed09.Text;
        10: Data[DataEnCours].Tel3 := Ed10.Text;
        11: Data[DataEnCours].Tel4 := Ed11.Text;
        12: Data[DataEnCours].Mail1 := Ed12.Text;
        13: Data[DataEnCours].Mail2 := Ed13.Text;
      end;
    end;
  end;
end;

procedure Fiche_vers_Data(DataEnCours: integer);
var
  n: integer;
begin
  for n := 1 to 13 do
    Edit_vers_Data(DataEnCours, n);
end;

procedure Data_vers_Edit(DataEnCours: integer);
begin
  with WdMain do
  begin
    with Data[DataEnCours] do
    begin
      Ed01.Text := Design;
      Ed02.Text := Com;
      Ed03.Text := Categ;

      Ed04.Text := Nom;
      Ed05.Text := Prenom;

      Ed06.Text := Rue;
      Ed07.Text := Ville;

      Ed08.Text := Tel1;
      Ed09.Text := Tel2;
      Ed10.Text := Tel3;
      Ed11.Text := Tel4;

      Ed12.Text := Mail1;
      Ed13.Text := Mail2;
    end;
    Edit1.Text := IntToStr(DataEnCours);
  end;
end;

procedure Edit_vers_Fiche_Initiale(DataEnCours: integer);
begin
  with WdMain do
  begin
    with Data[DataEnCours] do
    begin
      FicheMem1.Design := Design;
      FicheMem1.Com := Com;
      FicheMem1.Categ := Categ;

      FicheMem1.Nom := Nom;
      FicheMem1.Prenom := Prenom;

      FicheMem1.Rue := Rue;
      FicheMem1.Ville := Ville;

      FicheMem1.Tel1 := Tel1;
      FicheMem1.Tel2 := Tel2;
      FicheMem1.Tel3 := Tel3;
      FicheMem1.Tel4 := Tel4;

      FicheMem1.Mail1 := Mail1;
      FicheMem1.Mail2 := Mail2;
    end;
  end;
end;

procedure Fiche_Vide(DataEnCours: integer);
begin
  with WdMain do
  begin
    Ed01.Text := '';
    Ed02.Text := '';
    Ed03.Text := '';
    Ed04.Text := '';
    Ed05.Text := '';
    Ed06.Text := '';
    Ed07.Text := '';
    Ed08.Text := '';
    Ed09.Text := '';
    Ed10.Text := '';
    Ed11.Text := '';
    Ed12.Text := '';
    Ed13.Text := '';
  end;
  Fiche_vers_Data(DataEnCours);
  WdMain.ListBox1.Items[DataEnCours - 1] :=
    Data[DataEnCours].Nom + ' ' + Data[DataEnCours].Prenom;
  Modif := True;
end;

procedure Data_Fiche_Vide(n: integer);
begin
  with Data[n] do
  begin
    Design := '';
    Com := '';
    Categ := '';

    Nom := '';
    Prenom := '';

    Rue := '';
    Ville := '';

    Tel1 := '';
    Tel2 := '';
    Tel3 := '';
    Tel4 := '';

    Mail1 := '';
    Mail2 := '';
  end;
end;

procedure Data_Vide;
var
  n: integer;
begin
  for n := 1 to DataFichesMax_ do
    Data_Fiche_Vide(n);
end;

procedure Data_Sauve;
var
  fil: file of Data_;
begin
  AssignFile(fil, DataNom);
 {$i-}
  Rewrite(fil);
{$i+}
  if Ioresult = 0 then
  begin
  {$i-}
    Write(fil, Data);
{$i+}
    if Ioresult = 0 then
    begin
      Modif := False;
    end;
  end;
 {$i-}
  CloseFile(fil);
{$i+}
end;

procedure Data_Sauve_CSV;
var
  Txt: TextFile;
  n: integer;
begin
  with WdMain do
  begin
    AssignFile(Txt, DataNomCSV_);
  {$i-}
    Rewrite(Txt);
{$i+}
    if Ioresult = 0 then
    begin
      for n := 1 to DataFichesMax_ do
      begin
        with Data[n] do
        begin
     {$i-}
          Writeln(Txt,
            UTF8toANSI(Design) + ';' + UTF8toANSI(Com) + ';' +
            UTF8toANSI(Categ) + ';' + UTF8toANSI(Nom) + ';' +
            UTF8toANSI(Prenom) + ';' + UTF8toANSI(Rue) + ';' +
            UTF8toANSI(Ville) + ';' + UTF8toANSI(Tel1) + ';' +
            UTF8toANSI(Tel2) + ';' + UTF8toANSI(Tel3) + ';' +
            UTF8toANSI(Tel4) + ';' + UTF8toANSI(Mail1) + ';' + UTF8toANSI(Mail2)
            );
{$i+}
        end;
      end;
      ShowMessage(#13#10 + '  Données enregistrées dans le fichier "' +
        DataNomCSV_ + '".');
    end;
  {$i-}
    CloseFile(Txt);
{$i+}
  end;
end;

function Data_Lire: boolean;
var
  fil: file of Data_;
  Ok: boolean;
begin
  Ok := False;
  if FileExists(DataNom) then
  begin
    AssignFile(Fil, DataNom);
  {$i-}
    Reset(Fil);
{$i+}
    if Ioresult = 0 then
    begin
   {$i-}
      Read(Fil, Data);
{$i+}
      if Ioresult = 0 then
      begin
        WdMain.Panel3.Color := ClLime;
        Ok := True;
        Modif := False;
      end;
    end
    else
    begin
      WdMain.Panel3.Color := ColRouge_;
    end;
  {$i-}
    CloseFile(Fil);
{$i+}
  end;
  Result := Ok;
end;

procedure Box_Liste;
var
  n: integer;
begin
  with WdMain do
  begin
    for n := 1 to DataFichesMax_ do
      if n - 1 < ListBox1.Count then
      begin
        ListBox1.Items[n - 1] := Data[n].Nom + ' ' + Data[n].Prenom;
      end;
  end;
end;

procedure RechChampsOnOff(RecCh: integer);
begin
  with WdMain do
  begin
    case RecCh of
      //Normalisation des champs
      0:
      begin
        //1,2,3
        Pn01.Color := ColF10_;
        Ed01.Color := ColF11_;
        Pn02.Color := ColF10_;
        Ed02.Color := ColF11_;
        Pn03.Color := ColF10_;
        Ed03.Color := ColF11_;
        //4,5
        Pn04.Color := ColF20_;
        Ed04.Color := ColF21_;
        Pn05.Color := ColF20_;
        Ed05.Color := ColF21_;
        //6,7
        Pn06.Color := ColF30_;
        Ed06.Color := ColF31_;
        Pn07.Color := ColF30_;
        Ed07.Color := ColF31_;
        //8,9,10,11
        Pn08.Color := ColF40_;
        Ed08.Color := ColF41_;
        Pn09.Color := ColF40_;
        Ed09.Color := ColF41_;
        Pn10.Color := ColF40_;
        Ed10.Color := ColF41_;
        Pn11.Color := ColF40_;
        Ed11.Color := ColF41_;
        //12,13
        Pn12.Color := ColF50_;
        Ed12.Color := ColF51_;
        Pn13.Color := ColF50_;
        Ed13.Color := ColF51_;
      end;
      //Désignation
      1:
      begin
        Pn01.Color := ColF00_;
        Ed01.Color := ColF00_;
      end;
      //Commentaire
      2:
      begin
        Pn02.Color := ColF00_;
        Ed02.Color := ColF00_;
      end;
      //Catégorie
      3:
      begin
        Pn03.Color := ColF00_;
        Ed03.Color := ColF00_;
      end;
      //Nom
      4:
      begin
        Pn04.Color := ColF00_;
        Ed04.Color := ColF00_;
      end;
      //Prénom
      5:
      begin
        Pn05.Color := ColF00_;
        Ed05.Color := ColF00_;
      end;
      //Rue
      6:
      begin
        Pn06.Color := ColF00_;
        Ed06.Color := ColF00_;
      end;
      //Ville
      7:
      begin
        Pn07.Color := ColF00_;
        Ed07.Color := ColF00_;
      end;
      //Tel1
      8:
      begin
        Pn08.Color := ColF00_;
        Ed08.Color := ColF00_;
      end;
      //Tel2
      9:
      begin
        Pn09.Color := ColF00_;
        Ed09.Color := ColF00_;
      end;
      //Tel3
      10:
      begin
        Pn10.Color := ColF00_;
        Ed10.Color := ColF00_;
      end;
      //Tel4
      11:
      begin
        Pn11.Color := ColF00_;
        Ed11.Color := ColF00_;
      end;
      //Mail1
      12:
      begin
        Pn12.Color := ColF00_;
        Ed12.Color := ColF00_;
      end;
      //Mail2
      13:
      begin
        Pn13.Color := ColF00_;
        Ed13.Color := ColF00_;
      end;
    end;
    Panel2.UpDate;
  end;
end;

procedure Fiche_Inverser(DataEnCours1, DataEnCours2: integer);
var
  Mem: Fiche_;
begin
  with Mem do
  begin
    Design := Data[DataEnCours1].Design;
    Com := Data[DataEnCours1].Com;
    Categ := Data[DataEnCours1].Categ;

    Nom := Data[DataEnCours1].Nom;
    Prenom := Data[DataEnCours1].Prenom;

    Rue := Data[DataEnCours1].Rue;
    Ville := Data[DataEnCours1].Ville;

    Tel1 := Data[DataEnCours1].Tel1;
    Tel2 := Data[DataEnCours1].Tel2;
    Tel3 := Data[DataEnCours1].Tel3;
    Tel4 := Data[DataEnCours1].Tel4;

    Mail1 := Data[DataEnCours1].Mail1;
    Mail2 := Data[DataEnCours1].Mail2;
  end;
  with Data[DataEnCours1] do
  begin
    Design := Data[DataEnCours2].Design;
    Com := Data[DataEnCours2].Com;
    Categ := Data[DataEnCours2].Categ;

    Nom := Data[DataEnCours2].Nom;
    Prenom := Data[DataEnCours2].Prenom;

    Rue := Data[DataEnCours2].Rue;
    Ville := Data[DataEnCours2].Ville;

    Tel1 := Data[DataEnCours2].Tel1;
    Tel2 := Data[DataEnCours2].Tel2;
    Tel3 := Data[DataEnCours2].Tel3;
    Tel4 := Data[DataEnCours2].Tel4;

    Mail1 := Data[DataEnCours2].Mail1;
    Mail2 := Data[DataEnCours2].Mail2;
  end;
  with Data[DataEnCours2] do
  begin
    Design := Mem.Design;
    Com := Mem.Com;
    Categ := Mem.Categ;

    Nom := Mem.Nom;
    Prenom := Mem.Prenom;

    Rue := Mem.Rue;
    Ville := Mem.Ville;

    Tel1 := Mem.Tel1;
    Tel2 := Mem.Tel2;
    Tel3 := Mem.Tel3;
    Tel4 := Mem.Tel4;

    Mail1 := Mem.Mail1;
    Mail2 := Mem.Mail2;
  end;

end;

procedure Ficher_Inserrer_Vide;
var
  n, DataEnCours: integer;
begin
  with WdMain do
  begin
    DataEnCours := ListBox1.ItemIndex + 1;

    if If_Data_Fiche_Vide(DataFichesMax_) then
    begin
      RechChampsOnOff(0);
      for n := DataFichesMax_ downto DataEnCours + 1 do
      begin
        Data[n].Design := Data[n - 1].Design;
        Data[n].Com := Data[n - 1].Com;
        Data[n].Categ := Data[n - 1].Categ;

        Data[n].Nom := Data[n - 1].Nom;
        Data[n].Prenom := Data[n - 1].Prenom;

        Data[n].Rue := Data[n - 1].Rue;
        Data[n].Ville := Data[n - 1].Ville;

        Data[n].Tel1 := Data[n - 1].Tel1;
        Data[n].Tel2 := Data[n - 1].Tel2;
        Data[n].Tel3 := Data[n - 1].Tel3;
        Data[n].Tel4 := Data[n - 1].Tel4;

        Data[n].Mail1 := Data[n - 1].Mail1;
        Data[n].Mail2 := Data[n - 1].Mail2;
      end;
      Fiche_Vide(DataEnCours);
      Box_Liste;
      Edit_vers_Fiche_Initiale(DataEnCours);
    end
    else
    begin
      ShowMessage(' La dernière ligne doit être vide ! ');
    end;
  end;
end;

procedure Fiche_Supprimer;
var
  n, DataEnCours: integer;
begin
  with WdMain do
  begin
    DataEnCours := ListBox1.ItemIndex + 1;

    for n := DataEnCours to DataFichesMax_ - 1 do
    begin
      Data[n].Design := Data[n + 1].Design;
      Data[n].Com := Data[n + 1].Com;
      Data[n].Categ := Data[n + 1].Categ;

      Data[n].Nom := Data[n + 1].Nom;
      Data[n].Prenom := Data[n + 1].Prenom;

      Data[n].Rue := Data[n + 1].Rue;
      Data[n].Ville := Data[n + 1].Ville;

      Data[n].Tel1 := Data[n + 1].Tel1;
      Data[n].Tel2 := Data[n + 1].Tel2;
      Data[n].Tel3 := Data[n + 1].Tel3;
      Data[n].Tel4 := Data[n + 1].Tel4;

      Data[n].Mail1 := Data[n + 1].Mail1;
      Data[n].Mail2 := Data[n + 1].Mail2;
    end;
    Data_Fiche_Vide(DataFichesMax_);
    Box_Liste;
    Edit_vers_Fiche_Initiale(DataEnCours);
  end;
end;

procedure Fiche_Mem_Vide(Select: byte);
begin
  case Select of
    1: with FicheMem1 do
      begin
        Design := '';
        Com := '';
        Categ := '';

        Nom := '';
        Prenom := '';

        Rue := '';
        Ville := '';

        Tel1 := '';
        Tel2 := '';
        Tel3 := '';
        Tel4 := '';

        Mail1 := '';
        Mail2 := '';
      end;
    2: with FicheMem2 do
      begin
        Design := '';
        Com := '';
        Categ := '';

        Nom := '';
        Prenom := '';

        Rue := '';
        Ville := '';

        Tel1 := '';
        Tel2 := '';
        Tel3 := '';
        Tel4 := '';

        Mail1 := '';
        Mail2 := '';
      end;
  end;
end;

procedure Fiche_Copier(DataEnCours: integer);
begin
  with WdMain do
  begin
    with FicheMem2 do
    begin
      Design := Data[DataEnCours].Design;
      Com := Data[DataEnCours].Com;
      Categ := Data[DataEnCours].Categ;

      Nom := Data[DataEnCours].Nom;
      Prenom := Data[DataEnCours].Prenom;

      Rue := Data[DataEnCours].Rue;
      Ville := Data[DataEnCours].Ville;

      Tel1 := Data[DataEnCours].Tel1;
      Tel2 := Data[DataEnCours].Tel2;
      Tel3 := Data[DataEnCours].Tel3;
      Tel4 := Data[DataEnCours].Tel4;

      Mail1 := Data[DataEnCours].Mail1;
      Mail2 := Data[DataEnCours].Mail2;
    end;
    Panel4.Color := ClLime;
    CheckBox4.Enabled := True;
    CheckBox4.Checked := True;
    SpeedButton7.Enabled := True;
    SpeedButton6.Enabled := False;
  end;
end;

procedure Fiche_Coller(DataEnCours: integer);
begin
  with WdMain do
  begin
    with Data[DataEnCours] do
    begin
      Design := FicheMem2.Design;
      Com := FicheMem2.Com;
      Categ := FicheMem2.Categ;

      Nom := FicheMem2.Nom;
      Prenom := FicheMem2.Prenom;

      Rue := FicheMem2.Rue;
      Ville := FicheMem2.Ville;

      Tel1 := FicheMem2.Tel1;
      Tel2 := FicheMem2.Tel2;
      Tel3 := FicheMem2.Tel3;
      Tel4 := FicheMem2.Tel4;

      Mail1 := FicheMem2.Mail1;
      Mail2 := FicheMem2.Mail2;
    end;
  end;
end;

procedure Fiche_Monter;
var
  DataEnCours1, DataEnCours2: integer;
begin
  with WdMain do
  begin
    DataEnCours1 := ListBox1.ItemIndex + 1;
    if DataEnCours1 > 1 then
    begin
      DataEnCours2 := DataEnCours1 - 1;
      Fiche_Inverser(DataEnCours1, DataEnCours2);
    end;
    ListBox1.ItemIndex := DataEnCours2 - 1;
  end;
  Box_Liste;
end;

procedure Fiche_Descendre;
var
  DataEnCours1, DataEnCours2: integer;
begin
  with WdMain do
  begin
    DataEnCours1 := ListBox1.ItemIndex + 1;
    if DataEnCours1 < DataFichesMax_ then
    begin
      DataEnCours2 := DataEnCours1 + 1;
      Fiche_Inverser(DataEnCours1, DataEnCours2);
    end;
    ListBox1.ItemIndex := DataEnCours2 - 1;
  end;
  Box_Liste;
end;

procedure Fiche_Initiale_vers_Edit;
begin
  with WdMain do
  begin
    with FicheMem1 do
    begin
      Ed01.Text := Design;
      Ed02.Text := Com;
      Ed03.Text := Categ;

      Ed04.Text := Nom;
      Ed05.Text := Prenom;

      Ed06.Text := Rue;
      Ed07.Text := Ville;

      Ed08.Text := Tel1;
      Ed09.Text := Tel2;
      Ed10.Text := Tel3;
      Ed11.Text := Tel4;

      Ed12.Text := Mail1;
      Ed13.Text := Mail2;
    end;
  end;
end;

procedure Box_Vide;
var
  n: integer;
begin
  with WdMain do
  begin
    ListBox1.Clear;
    for n := 1 to DataFichesMax_ do
      ListBox1.Items.Add('');
    ListBox1.ItemIndex := 0;
    Edit1.Text := IntToStr(ListBox1.ItemIndex + 1);
    Edit_vers_Fiche_Initiale(1);
  end;
end;

procedure Recherche;
var
  Rech: string;
  Pos1: integer;
  Ok: boolean;

  function Cherche(s: string): boolean;
  var
    n: integer;
  begin
    n := 1;
    Ok := False;
    repeat
      if Copy(s, n, Length(Rech)) = Rech then
      begin
        Ok := True;
      end;
      Inc(n);
    until (Ok) or (n > Length(s) - Length(Rech) + 1);
    Result := Ok;
  end;

var
  Mem: array[1..DataChampsMax_] of string;
  DataEnCours: integer;
  n, p, Tr: integer;
  Sortie: boolean;
begin
  RechChampsOnOff(0);
  with WdMain do
  begin
    Rech := LowerCase(EdRech.Text);
    DataEnCours := ListBox1.ItemIndex + 1;
    Pos1 := DataEnCours;
    RechChamps := 0;

    Tr := 0;
    n := DataEnCours + 1;
    if n > DataFichesMax_ then
    begin
      n := 1;
      Tr := 1;
    end;

    Panel6.Caption := '';
    Sortie := False;
    Ok := False;
    repeat
      with Data[n] do
      begin
        Mem[1] := LowerCase(Design);
        Mem[2] := LowerCase(Com);
        Mem[3] := LowerCase(Categ);
        Mem[4] := LowerCase(Nom);
        Mem[5] := LowerCase(Prenom);
        Mem[6] := LowerCase(Rue);
        Mem[7] := LowerCase(Ville);
        Mem[8] := LowerCase(Tel1);
        Mem[9] := LowerCase(Tel2);
        Mem[10] := LowerCase(Tel3);
        Mem[11] := LowerCase(Tel4);
        Mem[12] := LowerCase(Mail1);
        Mem[13] := LowerCase(Mail2);
      end;

      p := 1;
      repeat
        //Recherche dans toute la base
        if Cherche(Mem[p]) then
        begin
          Ok := True;
          Pos1 := n - 1;
          RechChamps := p;
          case p of
            1: Panel6.Caption := 'Désignation';
            2: Panel6.Caption := 'Commentaire';
            3: Panel6.Caption := 'Catégorie';
            4: Panel6.Caption := 'Nom';
            5: Panel6.Caption := 'Prénom';
            6: Panel6.Caption := 'Rue';
            7: Panel6.Caption := 'Ville & Pays';
            8: Panel6.Caption := 'Tel1';
            9: Panel6.Caption := 'Tel2';
            10: Panel6.Caption := 'Tel3';
            11: Panel6.Caption := 'Tel4';
            12: Panel6.Caption := 'Mail1';
            13: Panel6.Caption := 'Mail2';
          end;
        end;
        Inc(p);
      until (Ok) or (p > DataChampsMax_);

      Inc(n);
      if n >= DataEnCours then
      begin
        if Tr = 1 then
          Sortie := True;
      end;
      if n > DataFichesMax_ then
      begin
        n := 1;
        Tr := 1;
      end;
      Application.ProcessMessages;
    until (Ok) or (Sortie);
    if Ok then
    begin
      if (Pos1 >= 0) and (Pos1 < ListBox1.Count) then
      begin
        ListBox1.ItemIndex := Pos1;
        Data_vers_Edit(ListBox1.ItemIndex + 1);
        RechChampsOnOff(RechChamps);
      end;
    end;
    ActiveControl := EdRech;
  end;
end;

procedure Nd_Espace(Select: integer);
var
  s, t: string;
  n: integer;
begin
  with WdMain do
  begin
    case Select of
      1: t := Ed08.Text;
      2: t := Ed09.Text;
      3: t := Ed10.Text;
      4: t := Ed11.Text;
    end;
    s := '';
    for n := 1 to Length(t) do
      if t[n] in ['0'..'9'] then
        s := s + t[n];

    t := '';
    for n := 1 to Length(s) do
    begin
      t := t + s[n];
      if n < Length(s) then
        case n of
          2, 4, 6, 8, 10, 12, 14, 16, 18, 20: t := t + ' ';
        end;
    end;

    case Select of
      1: Ed08.Text := t;
      2: Ed09.Text := t;
      3: Ed10.Text := t;
      4: Ed11.Text := t;
    end;
  end;
end;

procedure Init;
begin
  with WdMain do
  begin
    SpeedButton1.Enabled := False;
    Box_Vide;
    //Data
    DataNom := DataNom_;
    Data_Vide;
    //Timer
    Timer1.Enabled := True;
    //Recherche
    RechChamps := 0;
    //Mem. Fiche
    Fiche_Mem_Vide(1);
    //Mem. Copier/Coller
    Fiche_Mem_Vide(2);
  end;
end;

procedure TWdMain.SpeedButton10Click(Sender: TObject);
begin
  Fiche_Initiale_vers_Edit;
end;

procedure TWdMain.SpeedButton11Click(Sender: TObject);
begin
  Nd_Espace(1);
end;

procedure TWdMain.SpeedButton12Click(Sender: TObject);
begin
  Nd_Espace(2);
end;

procedure TWdMain.SpeedButton13Click(Sender: TObject);
begin
  Nd_Espace(3);
end;

procedure TWdMain.SpeedButton14Click(Sender: TObject);
begin
  Nd_Espace(4);
end;

procedure Sauver;
begin
  RechChampsOnOff(0);
  with WdMain do
  begin
    Panel2.Color := ColRouge_;
    Panel2.Update;
    Data_Sauve;
    Sleep(500);
    Panel2.Color := ColFond2_;
    Edit_vers_Fiche_Initiale(ListBox1.ItemIndex);
  end;
end;

procedure TWdMain.MenuItem2Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.MenuItem3Click(Sender: TObject);
begin
  //Création fichier DATA
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Sauver;
end;

procedure TWdMain.MenuItem4Click(Sender: TObject);
begin
  Sauver;
end;

procedure TWdMain.MenuItem8Click(Sender: TObject);
begin
  Data_Sauve_CSV;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  if MessageDlg('   Effacer la fiche ?   ', mtConfirmation,
    [mbYes, mbNo, mbIgnore], 0) = mrYes then
  begin
    RechChampsOnOff(0);
    Fiche_Vide(ListBox1.ItemIndex + 1);
  end;
end;

procedure TWdMain.SpeedButton3Click(Sender: TObject);
begin
  Ficher_Inserrer_Vide;
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  if If_Data_Fiche_Vide(ListBox1.ItemIndex + 1) then
  begin
    RechChampsOnOff(0);
    Fiche_Supprimer;
  end
  else
  begin
    if MessageDlg('  La fiche n''est pas vide.' + #10 + '  Supprimer la fiche ?   ',
      mtConfirmation, [mbYes, mbNo, mbIgnore], 0) = mrYes then
    begin
      RechChampsOnOff(0);
      Fiche_Supprimer;
    end;
  end;
end;

procedure TWdMain.SpeedButton5Click(Sender: TObject);
begin
  RechChampsOnOff(0);
  Fiche_Monter;
end;

procedure TWdMain.SpeedButton9Click(Sender: TObject);
begin
  RechChampsOnOff(0);
  Fiche_Descendre;
end;

procedure TWdMain.SpeedButton6Click(Sender: TObject);
begin
  RechChampsOnOff(0);
  Fiche_Copier(ListBox1.ItemIndex + 1);
end;

procedure TWdMain.SpeedButton7Click(Sender: TObject);
var
  DataEnCours: integer;
  Ok: boolean;
begin
  //Coller
  if CheckBox4.Checked then
  begin
    Ok := True;
    if not If_Data_Fiche_Vide(ListBox1.ItemIndex + 1) then
    begin
      if MessageDlg('  La fiche n''est pas vide.' + #10 +
        '  Remplacer tout de même ?   ', mtConfirmation,
        [mbYes, mbNo, mbIgnore], 0) = mrYes then
      begin
        Ok := True;
      end
      else
      begin
        Ok := False;
      end;
    end;
    if Ok then
    begin
      DataEnCours := ListBox1.ItemIndex + 1;
      Fiche_Coller(DataEnCours);
      Data_vers_Edit(DataEnCours);
      WdMain.ListBox1.Items[DataEnCours - 1] :=
        Data[DataEnCours].Nom + ' ' + Data[DataEnCours].Prenom;
      Modif := True;

      Fiche_Mem_Vide(2);
      Panel4.Color := ColFond2_;
      CheckBox4.Enabled := False;
      SpeedButton6.Enabled := True;
      SpeedButton7.Enabled := False;
    end;
  end;
end;

procedure TWdMain.SpeedButton8Click(Sender: TObject);
begin
  Recherche;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if FileExists(DataNom) then
  begin
    if Data_Lire then
    begin
      SpeedButton1.Enabled := True;
    end
    else
    begin
      ShowMessage(' Erreur en lecture du fichier Data.');
    end;
  end
  else
  begin
    if MessageDlg('   Création de la base de donnée ?   ', mtConfirmation,
      [mbYes, mbNo, mbIgnore], 0) = mrYes then
    begin
      Data_Sauve;
      Panel3.Color := ClLime;
      SpeedButton1.Enabled := True;
    end;
  end;

  Data_Nb_Fiches;
  ListBox1.ItemIndex := 0;
  Box_Liste;
  Data_vers_Edit(ListBox1.ItemIndex + 1);
end;

procedure TWdMain.Timer2Timer(Sender: TObject);
begin
  Panel5.Caption := TimeToStr(Now);
  if Date > MemDate then
  begin
    MemDate := Date;
    Panel9.Caption := Jour_Date;
  end;
end;

procedure TWdMain.ListBox1Click(Sender: TObject);
begin
  RechChampsOnOff(0);
  Data_vers_Edit(ListBox1.ItemIndex + 1);
  Edit_vers_Fiche_Initiale(ListBox1.ItemIndex + 1);
  ActiveControl := Ed04;
end;

procedure TWdMain.Ed01Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 1);
end;

procedure TWdMain.CheckBox4Change(Sender: TObject);
begin
  with WdMain do
  begin
    if not CheckBox4.Checked then
    begin
      Fiche_Mem_Vide(2);
      Panel4.Color := ColFond2_;
      CheckBox4.Enabled := False;
      SpeedButton6.Enabled := True;
      SpeedButton7.Enabled := False;
    end;
  end;
end;

procedure TWdMain.CheckBox1Change(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
    Ed04.Text := UpperCase(Ed04.Text);
  end
  else
  begin
    Ed04.Text := LowerCase(Ed04.Text);
  end;
end;

procedure TWdMain.Ed02Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 2);
end;

procedure TWdMain.Ed03Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 3);
end;

procedure TWdMain.Ed04Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 4);
  ListBox1.Items[ListBox1.ItemIndex] := Ed04.Text + ' ' + Ed05.Text;
end;

procedure TWdMain.Ed05Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 5);
  ListBox1.Items[ListBox1.ItemIndex] := Ed04.Text + ' ' + Ed05.Text;
end;

procedure TWdMain.Ed06Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 6);
end;

procedure TWdMain.Ed07Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 7);
end;

procedure TWdMain.Ed08Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 8);
end;

procedure TWdMain.Ed09Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 9);
end;

procedure TWdMain.Ed10Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 10);
end;

procedure TWdMain.Ed11Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 11);
end;

procedure TWdMain.Ed12Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 12);
end;

procedure TWdMain.Ed13Change(Sender: TObject);
begin
  Edit_vers_Data(ListBox1.ItemIndex + 1, 13);
end;

procedure TWdMain.EdRechChange(Sender: TObject);
begin
  if EdRech.Text = '' then
  begin
    RechChampsOnOff(0);
    Panel6.Caption := '';
  end;
end;

procedure TWdMain.EdRechKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Key := 0;
    Recherche;
  end;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';
  WdMain.Caption := Version_;

  MemDate := Date;
  Panel9.Caption := Jour_Date;

  Init;
  ActiveControl := EdRech;
end;

end.
